
/* Support for dynamic loading of extension modules */


#include "Python.h"
#include "importdl.h"
#include	"dynld.h"

#define FUNCNAME_PATTERN "init%.200s"
const struct filedescr _PyImport_DynLoadFiletab[] = {
	{".d", "rb", C_EXTENSION},
	{0, 0}
};

static Dynobj*
load(int fd)
{
	Dynobj *o;
	
	o = dynloadfd(fd, _exporttab, dyntabsize(_exporttab), 0);
	return o;
}

void
dumpsyms(Dynsym *t, int n, ulong base)
{
	int i;

	print("%d symbols:\n", n);
	for(i=0; i<n; i++, t++)
		print("\t%.8lux=%.8lux %.8lux %s\n", t->addr, t->addr-base, t->sig, t->name);
}

dl_funcptr _PyImport_GetDynLoadFunc(const char *fqname, const char *shortname,
				    const char *pathname, FILE *fp)
{
	int fd;
	dl_funcptr p;
	char errBuf[256];
	Dynobj *o;
	char funcname[258];

	fd = open(pathname, OREAD);
	if(fd < 0) {
		snprint(errBuf, sizeof errBuf, "cannot open %s: %r", pathname);
		PyErr_SetString(PyExc_ImportError, errBuf);
		return NULL;
	}

	o = dynloadfd(fd, _exporttab, dyntabsize(_exporttab), 0);
	close(fd);

	if (! o) {
		snprint(errBuf, sizeof errBuf, "cannot LOAD %s: %r", pathname);
		PyErr_SetString(PyExc_ImportError, errBuf);
		return NULL;
	}

	dumpsyms(o->export, o->nexport, (ulong)o->base);

print("import fqname :%s:\n", shortname);
	PyOS_snprintf(funcname, sizeof(funcname), FUNCNAME_PATTERN, shortname);

	p = dynimport(o, funcname, 0);
print("p is %p\n", p);
	if(p == nil){

		snprint(errBuf, sizeof errBuf,"cannot find %s: %r", funcname);
		PyErr_SetString(PyExc_ImportError, errBuf);
		return NULL;
	}
	close(fd);
	return p;

}
